/*! 
 *  \brief     Pretty nice class.
 *  \details   This class is used to demonstrate a number of section commands.
 *  \author    John Doe
 *  \author    Jan Doe
 *  \version   4.1a
 *  \date      1990-2011
 *  \pre       First initialize the system.
 *  \bug       Not all memory is freed when deleting an object of this class.
 *  \warning   Improper use can crash your application
 *  \copyright GNU Public License.
 */

#include <stdio.h>
#include <math.h>
#include <stdlib.h> 

/**  Calcul la surface corporelle
  @param t : taille en m
  @param p : poids en kg
  @return la surface corporelle */
float surfaceCorporelle (float p, float t) {
	return (0.2*powf(p,0.4)*powf(t,0.7));
}

/**  Calcul le metabolisme de base
  @param sc : surface corporelle
  @param a : age
  @return le metabolisme de base */
float metaBase (float sc, int a) {
	int alpha=0 ;
	if (a>=10 && a<15) alpha = 45 ;
	if (a>=15 && a<20) alpha = 40 ;
	if (a>=20 && a<60) alpha = 35 ;
	else alpha = 30 ;
	return (24*alpha*sc);
}

/**  prise en compte du sexe dans le metabolisme de base
  @param mb : le métabolisme initial
  @param sexe : 0 si homme, 1 si femme
  @param alaitmt : 1 si alaitement, 0 sinon
  @return le metabolisme de base modifié */
float metaBaseSexe ( float mb, int sexe, int alaitmt ) {
	if (sexe == 1) {
		mb = mb*0.9 ;
		if (alaitmt == 1) mb = mb + 600 ;
	}
	return mb ;
}

void ihm () {
	
	float poids, taille, sc, mb, h ;	
	int sexe, age, al ;
	printf("Entrez poids (kg) et taille (m) séparés par un espace : ") ;
	scanf("%f %f", &poids, &taille) ;
	sc  = surfaceCorporelle (poids, taille) ;
	printf ("Votre sc = %f \n ", sc) ;
	printf("Quel est votre age : ") ;	
	scanf("%d", &age) ;
	mb = metaBase(sc, age); 
	
	printf ("Votre mb = %f \n ", mb) ;
	printf("Quel est votre sexe ? - Entrez 0 pour Homme et 1 pour Femme :") ;	
	scanf("%d", &sexe) ;
	if (sexe == 1) {
		printf("Etes vous enceinte ou allaitez-vous ? (1 pour oui, 0 pour non) :");
		scanf("%d", &al) ;
	}
	else al =0 ;
    mb = metaBaseSexe (mb, sexe, al) ;
	
	printf("Quel est votre activité du moment ? \nTapez le nombre d'heures par jour passées à  :\n") ;
	printf(" se reposer : ") ;
	scanf("%f", &h) ;
	printf(" être assis : ") ;
 	scanf("%f", &h) ;
	mb = mb + h*50 ;
	printf(" pratiquer de l'exercice léger : ") ;
	scanf("%f", &h) ;
	mb = mb + h*100 ;
	printf(" pratiquer un sport : ") ;
	scanf("%f", &h) ;
	mb = mb + h*200 ;
		
	printf ("Votre ration calorique journalière nécessaire est de : %f calories.\n", mb);
	
}


int main(void ) {
	float sc ;
	float mb, mbs ;
	sc = surfaceCorporelle (55, 1.7) ; // doit retourner 1.440421
	if (fabs(sc-1.440421)/sc <1e-6 ) { printf (" surfaceCorporelle OK \n") ; }
	mb = metaBase (1.440421, 20) ; // doit retourner 1209.953
	if (fabs(mb - 1209.953)/mb <1e-6 ){ printf (" metabase OK \n") ; }
	mbs = metaBaseSexe (1209.953 , 1, 1 )  ;  // doit retourner 1688.958
	if (fabs(mbs - 1688.958)/mbs<1e-6 ) { printf (" metaBaseSexe OK \n") ; }
	return (EXIT_SUCCESS) ;
	//~ printf ("mbs = %f\n", metaBaseSexe (1209.953613 , 1, 1 ) ) ;  // doit retourner 1688.958252
	
	//ihm() ;


}
