/*! 
 *  \brief     Recherche de zéro par dichotomie 
 *  \author    Ph Lefebvre
 *  \version   0.1
 *  \date      2020 
 *  \warning   Improper user input can crash the application
 *  \copyright GNU Public License.
 */
 
#include <stdio.h>
#include <stdlib.h>


double rechercheZero (double g, double d, double p) ;
int signe( double x ) ;
double f(double x ) ; 

int main(void)
{
    double x ;
    x = rechercheZero (0, 100, 1e-9) ;
    printf("f(x)=0 pour x=%lf\n", x) ;
    return(EXIT_SUCCESS);
}

double rechercheZero (double g, double d, double p) 
{
    double m = (d+g)/2.0;

    if ((d-g) < p) 
        return (g) ;
    if (signe(f(m)) * signe(f(g)) == 1 ) 
        return (rechercheZero(m, d, p)) ;
    else return (rechercheZero(g, m, p)) ;
}

int signe( double x) 
{    
	if (x>0) 
        return(1);
    else return (-1) ;
}

double f(double x) 
{
    return(-1200.0 +x*(-598.0 +x*(3+ x)));
}

