/*! 
 *  \brief     Gestion simple de fiches - TP 8 ENSICAEN 1A
 *  \author    Ph Lefebvre
 *  \version   1.0
 *  \date      2014
 */

#include <stdio.h>
#include <math.h>


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct sfiche {
	char nom[20]; 
	char prenom[20];
	int num[5]; // tableau contenant le numéro de téléphone
} Fiche ;

typedef struct srep {
	Fiche **tab;
	int tabLen; // taille du tableau des fiches
} Repertoire ;

/**  alloue l'espace mémoire nécessaire pour une fiche
  @param n : nom
  @param p : prenom
  @param t : numéro de téléphone
  @return pointeur sur la zone créée
  */
Fiche *creerFiche ( char *n, char *p, int *t) {
    Fiche *f ;
    int i ;
    f=(Fiche *) malloc(sizeof(Fiche)) ;
    strcpy(f->nom, n);
    strcpy(f->prenom, p);
    for (i=0 ; i< 5 ; i++)
        f->num[i]=t[i] ;
    return f;
}

/**  alloue l'espace mémoire nécessaire pour le tableau de pointeurs de fiches
  @param n : nombre de fiches.
  @return  retourne un répertoire vide de n fiches.
  */
Repertoire creerRep( int n )  {
    Repertoire r ;
    r.tab=(Fiche **) calloc(n ,sizeof(Fiche*)) ;
    r.tabLen=n ;
    return r;
}

/**  ajoute la fiche pointée par f au tableau de fiches.
L'ajout se fait à la première case libre.
  @param r : répertoire
  @param pf : pointeur sur la fiche à insérer
  @return rien
  */
void ajouterFiche(Repertoire r, Fiche *pf ) {
   int i;
   for (i=0 ; i<r.tabLen ; i++)
        if (r.tab[i]==NULL) break ;
   if (i==r.tabLen) return ;
   else r.tab[i]=pf ;
   return ;
}

/**  affiche les renseignements d'une fiche.
  @param f : pointeur sur la fiche à afficher
  @return rien
  */
void afficherFiche( Fiche f ) {
    int i ;
    printf ("[%s %s ",f.nom, f.prenom) ; 
    for (i=0 ; i< 5 ; i++)
        printf ("%d ",f.num[i]) ;
    printf(" ]\n");
}
  
 
/**  affiche les fiches du répertoire.
  @param r : répertoire
  @return rien
  */
void afficherRep( Repertoire r )  {
   int i;
    printf ("Repertoire : \n"); 
   for (i=0 ; i<r.tabLen ; i++)
        if (r.tab[i]!=NULL)
            afficherFiche (*(r.tab[i])) ;
}

/**  retourne un répertoire lu à partir d'un fichier texte
  @param nomFic : nom du fichier texte
  @return  retourne le répertoire 
  */
Repertoire lireRep (char *nomFic) {
    FILE *fp ;
    Fiche *f ;
    char nom[20], prenom[20] ;
    int num[5] ;
    Repertoire r ;
    r = creerRep(10) ; // attention le fichier ne doit pas contenir plus de 10 enregistrements
    fp = fopen( nomFic, "r" ) ;
    if (fp == NULL ) {
		printf("Pb ouverture %s\n", nomFic) ;
		return(r) ; // retourne un répertoire vide
	}
	while (fscanf (fp, "%s %s %d %d %d %d %d", nom, prenom, &num[0], &num[1], \
			&num[2], &num[3], &num[4] )==7 ) {
		f = creerFiche(nom, prenom, num );
		ajouterFiche(r, f);
	}
	fclose(fp) ;
	return(r) ;
}

/** main de validation des fonctions 
 * 
 * Trace d'exécution : 
[Pouzin Louis 2 31 45 27 50  ]
[BonBeurre Jean 6 27 26 25 24  ]
Repertoire : 
[Pouzin Louis 2 31 45 27 50  ]
[BonBeurre Jean 6 27 26 25 24  ]

*/
int main() {
     Fiche *pf1, *pf2 ;
    int t[5] ;
    Repertoire r ;
    t[0]= 2 ; t[1]= 31 ; t[2]= 45 ; t[3]= 27 ; t[4]=50 ;
    int t2[] = {06, 27, 26, 25,  24} ;
    pf1 = creerFiche("Pouzin", "Louis", t);
    pf2 = creerFiche("BonBeurre", "Jean", t2 ) ;
    afficherFiche( *pf1 ) ;
    afficherFiche( *pf2 ) ;
	r = creerRep ( 7 ) ;
    ajouterFiche( r, pf1) ;
    ajouterFiche( r, pf2) ;
	afficherRep( r ) ;
	return(0) ;
}	




